/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.296 Revision 1.382
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.296 2008/02/13 20:50:06 wolf31o2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.382 2012/02/14 16:08:54 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
18inherit multilib portability 21inherit multilib portability user
19 22
20DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
24
25if has "${EAPI:-0}" 0 1 2; then
21 26
22# @FUNCTION: epause 27# @FUNCTION: epause
23# @USAGE: [seconds] 28# @USAGE: [seconds]
24# @DESCRIPTION: 29# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 31# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 33# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 34epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 36}
32 37
33# @FUNCTION: ebeep 38# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 39# @USAGE: [number of beeps]
35# @DESCRIPTION: 40# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 41# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 42# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 44# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 45ebeep() {
41 local n 46 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 49 echo -ne "\a"
47 sleep 1 52 sleep 1
48 done 53 done
49 fi 54 fi
50} 55}
51 56
52# Default directory where patches are located 57else
58
59ebeep() {
60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
61}
62
63epause() {
64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
121}
122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
131
132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
184}
185
186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
53EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
54# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
55EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
231# @VARIABLE: EPATCH_OPTS
232# @DESCRIPTION:
56# Default options for patch 233# Default options for patch:
234# @CODE
57# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 235# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
58# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 236# --no-backup-if-mismatch - do not leave .orig files behind
59# Set -E to automatically remove empty files. 237# -E - automatically remove empty files
238# @CODE
60EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 239EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
240# @VARIABLE: EPATCH_EXCLUDE
241# @DESCRIPTION:
61# List of patches not to apply. Not this is only file names, 242# List of patches not to apply. Note this is only file names,
62# and not the full path .. 243# and not the full path. Globs accepted.
63EPATCH_EXCLUDE="" 244EPATCH_EXCLUDE=""
245# @VARIABLE: EPATCH_SINGLE_MSG
246# @DESCRIPTION:
64# Change the printed message for a single patch. 247# Change the printed message for a single patch.
65EPATCH_SINGLE_MSG="" 248EPATCH_SINGLE_MSG=""
249# @VARIABLE: EPATCH_MULTI_MSG
250# @DESCRIPTION:
66# Change the printed message for multiple patches. 251# Change the printed message for multiple patches.
67EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 252EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
68# Force applying bulk patches even if not following the style: 253# @VARIABLE: EPATCH_FORCE
69# 254# @DESCRIPTION:
70# ??_${ARCH}_foo.${EPATCH_SUFFIX} 255# Only require patches to match EPATCH_SUFFIX rather than the extended
71# 256# arch naming style.
72EPATCH_FORCE="no" 257EPATCH_FORCE="no"
73 258
74# This function is for bulk patching, or in theory for just one 259# @FUNCTION: epatch
75# or two patches. 260# @USAGE: [patches] [dirs of patches]
261# @DESCRIPTION:
262# epatch is designed to greatly simplify the application of patches. It can
263# process patch files directly, or directories of patches. The patches may be
264# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
265# the -p option as epatch will automatically attempt -p0 to -p5 until things
266# apply successfully.
76# 267#
77# It should work with .bz2, .gz, .zip and plain text patches. 268# If you do not specify any options, then epatch will default to the directory
78# Currently all patches should be the same format. 269# specified by EPATCH_SOURCE.
79# 270#
80# You do not have to specify '-p' option to patch, as it will 271# When processing directories, epatch will apply all patches that match:
81# try with -p0 to -p5 until it succeed, or fail at -p5. 272# @CODE
82# 273# if ${EPATCH_FORCE} != "yes"
83# Above EPATCH_* variables can be used to control various defaults,
84# bug they should be left as is to ensure an ebuild can rely on
85# them for.
86#
87# Patches are applied in current directory.
88#
89# Bulk Patches should preferibly have the form of:
90#
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 274# ??_${ARCH}_foo.${EPATCH_SUFFIX}
275# else
276# *.${EPATCH_SUFFIX}
277# @CODE
278# The leading ?? are typically numbers used to force consistent patch ordering.
279# The arch field is used to apply patches only for the host architecture with
280# the special value of "all" means apply for everyone. Note that using values
281# other than "all" is highly discouraged -- you should apply patches all the
282# time and let architecture details be detected at configure/compile time.
92# 283#
93# For example: 284# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
285# for patches to apply.
94# 286#
95# 01_all_misc-fix.patch.bz2 287# Refer to the other EPATCH_xxx variables for more customization of behavior.
96# 02_sparc_another-fix.patch.bz2
97#
98# This ensures that there are a set order, and you can have ARCH
99# specific patches.
100#
101# If you however give an argument to epatch(), it will treat it as a
102# single patch that need to be applied if its a file. If on the other
103# hand its a directory, it will set EPATCH_SOURCE to this.
104#
105# <azarah@gentoo.org> (10 Nov 2002)
106#
107epatch() { 288epatch() {
108 _epatch_draw_line() { 289 _epatch_draw_line() {
290 # create a line of same length as input string
109 [[ -z $1 ]] && set "$(printf "%65s" '')" 291 [[ -z $1 ]] && set "$(printf "%65s" '')"
110 echo "${1//?/=}" 292 echo "${1//?/=}"
111 } 293 }
112 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
113 local PIPE_CMD=""
114 local STDERR_TARGET="${T}/$$.out"
115 local PATCH_TARGET="${T}/$$.patch"
116 local PATCH_SUFFIX=""
117 local SINGLE_PATCH="no"
118 local x=""
119 294
120 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 295 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
121 296
122 if [ "$#" -gt 1 ] 297 # Let the rest of the code process one user arg at a time --
123 then 298 # each arg may expand into multiple patches, and each arg may
299 # need to start off with the default global EPATCH_xxx values
300 if [[ $# -gt 1 ]] ; then
124 local m="" 301 local m
125 for m in "$@" ; do 302 for m in "$@" ; do
126 epatch "${m}" 303 epatch "${m}"
127 done 304 done
128 return 0 305 return 0
129 fi 306 fi
130 307
131 if [ -n "$1" -a -f "$1" ] 308 local SINGLE_PATCH="no"
132 then 309 # no args means process ${EPATCH_SOURCE}
310 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
311
312 if [[ -f $1 ]] ; then
133 SINGLE_PATCH="yes" 313 SINGLE_PATCH="yes"
134 314 set -- "$1"
135 local EPATCH_SOURCE="$1" 315 # Use the suffix from the single patch (localize it); the code
316 # below will find the suffix for us
136 local EPATCH_SUFFIX="${1##*\.}" 317 local EPATCH_SUFFIX=$1
137 318
138 elif [ -n "$1" -a -d "$1" ] 319 elif [[ -d $1 ]] ; then
139 then 320 # Some people like to make dirs of patches w/out suffixes (vim)
140 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 321 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
141 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 322
323 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
324 # Re-use EPATCH_SOURCE as a search dir
325 epatch "${EPATCH_SOURCE}/$1"
326 return $?
327
328 else
329 # sanity check ... if it isn't a dir or file, wtf man ?
330 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
331 echo
332 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
333 eerror
334 eerror " ${EPATCH_SOURCE}"
335 eerror " ( ${EPATCH_SOURCE##*/} )"
336 echo
337 die "Cannot find \$EPATCH_SOURCE!"
338 fi
339
340 local PIPE_CMD
341 case ${EPATCH_SUFFIX##*\.} in
342 xz) PIPE_CMD="xz -dc" ;;
343 lzma) PIPE_CMD="lzma -dc" ;;
344 bz2) PIPE_CMD="bzip2 -dc" ;;
345 gz|Z|z) PIPE_CMD="gzip -dc" ;;
346 ZIP|zip) PIPE_CMD="unzip -p" ;;
347 *) ;;
348 esac
349
350 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
351
352 local x
353 for x in "$@" ; do
354 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
355 # didn't match anything, ignore continue on
356 [[ ! -f ${x} ]] && continue
357
358 local patchname=${x##*/}
359
360 # Apply single patches, or forced sets of patches, or
361 # patches with ARCH dependant names.
362 # ???_arch_foo.patch
363 # Else, skip this input altogether
364 local a=${patchname#*_} # strip the ???_
365 a=${a%%_*} # strip the _foo.patch
366 if ! [[ ${SINGLE_PATCH} == "yes" || \
367 ${EPATCH_FORCE} == "yes" || \
368 ${a} == all || \
369 ${a} == ${ARCH} ]]
142 then 370 then
143 local EPATCH_SOURCE="$1/*" 371 continue
372 fi
373
374 # Let people filter things dynamically
375 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
376 # let people use globs in the exclude
377 eshopts_push -o noglob
378
379 local ex
380 for ex in ${EPATCH_EXCLUDE} ; do
381 if [[ ${patchname} == ${ex} ]] ; then
382 eshopts_pop
383 continue 2
384 fi
385 done
386
387 eshopts_pop
388 fi
389
390 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
391 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
392 einfo "${EPATCH_SINGLE_MSG}"
393 else
394 einfo "Applying ${patchname} ..."
395 fi
144 else 396 else
145 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 397 einfo " ${patchname} ..."
146 fi 398 fi
147 else 399
148 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 400 # most of the time, there will only be one run per unique name,
149 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 401 # but if there are more, make sure we get unique log filenames
150 then 402 local STDERR_TARGET="${T}/${patchname}.out"
151 EPATCH_SOURCE="$1" 403 if [[ -e ${STDERR_TARGET} ]] ; then
404 STDERR_TARGET="${T}/${patchname}-$$.out"
405 fi
406
407 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
408
409 # Decompress the patch if need be
410 local count=0
411 local PATCH_TARGET
412 if [[ -n ${PIPE_CMD} ]] ; then
413 PATCH_TARGET="${T}/$$.patch"
414 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
415
416 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
417 echo
418 eerror "Could not extract patch!"
419 #die "Could not extract patch!"
420 count=5
421 break
152 fi 422 fi
423 else
424 PATCH_TARGET=${x}
425 fi
153 426
427 # Check for absolute paths in patches. If sandbox is disabled,
428 # people could (accidently) patch files in the root filesystem.
429 # Or trigger other unpleasantries #237667. So disallow -p0 on
430 # such patches.
431 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
432 if [[ -n ${abs_paths} ]] ; then
433 count=1
434 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
435 fi
436 # Similar reason, but with relative paths.
437 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
438 if [[ -n ${rel_paths} ]] ; then
439 eqawarn "QA Notice: Your patch uses relative paths '../'."
440 eqawarn " In the future this will cause a failure."
441 eqawarn "${rel_paths}"
442 fi
443
444 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
445 while [[ ${count} -lt 5 ]] ; do
446 # Generate some useful debug info ...
447 (
448 _epatch_draw_line "***** ${patchname} *****"
154 echo 449 echo
155 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 450 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
451 echo
452 _epatch_draw_line "***** ${patchname} *****"
453 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
454 ret=$?
455 echo
456 echo "patch program exited with status ${ret}"
457 exit ${ret}
458 ) >> "${STDERR_TARGET}"
459
460 if [ $? -eq 0 ] ; then
461 (
462 _epatch_draw_line "***** ${patchname} *****"
463 echo
464 echo "ACTUALLY APPLYING ${patchname} ..."
465 echo
466 _epatch_draw_line "***** ${patchname} *****"
467 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
468 ret=$?
469 echo
470 echo "patch program exited with status ${ret}"
471 exit ${ret}
472 ) >> "${STDERR_TARGET}"
473
474 if [ $? -ne 0 ] ; then
475 echo
476 eerror "A dry-run of patch command succeeded, but actually"
477 eerror "applying the patch failed!"
478 #die "Real world sux compared to the dreamworld!"
479 count=5
480 fi
481 break
482 fi
483
484 : $(( count++ ))
485 done
486
487 # if we had to decompress the patch, delete the temp one
488 if [[ -n ${PIPE_CMD} ]] ; then
489 rm -f "${PATCH_TARGET}"
490 fi
491
492 if [[ ${count} -ge 5 ]] ; then
493 echo
494 eerror "Failed Patch: ${patchname} !"
495 eerror " ( ${PATCH_TARGET} )"
156 eerror 496 eerror
157 eerror " ${EPATCH_SOURCE}" 497 eerror "Include in your bugreport the contents of:"
158 eerror " ( ${EPATCH_SOURCE##*/} )" 498 eerror
499 eerror " ${STDERR_TARGET}"
159 echo 500 echo
160 die "Cannot find \$EPATCH_SOURCE!"
161 fi
162
163 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
164 fi
165
166 case ${EPATCH_SUFFIX##*\.} in
167 bz2)
168 PIPE_CMD="bzip2 -dc"
169 PATCH_SUFFIX="bz2"
170 ;;
171 gz|Z|z)
172 PIPE_CMD="gzip -dc"
173 PATCH_SUFFIX="gz"
174 ;;
175 ZIP|zip)
176 PIPE_CMD="unzip -p"
177 PATCH_SUFFIX="zip"
178 ;;
179 *)
180 PIPE_CMD="cat"
181 PATCH_SUFFIX="patch"
182 ;;
183 esac
184
185 if [ "${SINGLE_PATCH}" = "no" ]
186 then
187 einfo "${EPATCH_MULTI_MSG}"
188 fi
189 for x in ${EPATCH_SOURCE}
190 do
191 # New ARCH dependant patch naming scheme ...
192 #
193 # ???_arch_foo.patch
194 #
195 if [ -f ${x} ] && \
196 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
197 [ "${EPATCH_FORCE}" = "yes" ])
198 then
199 local count=0
200 local popts="${EPATCH_OPTS}"
201 local patchname=${x##*/}
202
203 if [ -n "${EPATCH_EXCLUDE}" ]
204 then
205 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
206 then
207 continue
208 fi
209 fi
210
211 if [ "${SINGLE_PATCH}" = "yes" ]
212 then
213 if [ -n "${EPATCH_SINGLE_MSG}" ]
214 then
215 einfo "${EPATCH_SINGLE_MSG}"
216 else
217 einfo "Applying ${patchname} ..."
218 fi
219 else
220 einfo " ${patchname} ..."
221 fi
222
223 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
224 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
225
226 # Allow for prefix to differ ... im lazy, so shoot me :/
227 while [ "${count}" -lt 5 ]
228 do
229 # Generate some useful debug info ...
230 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
231 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
232
233 if [ "${PATCH_SUFFIX}" != "patch" ]
234 then
235 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
236 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
237 else
238 PATCH_TARGET="${x}"
239 fi
240
241 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
242 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
243
244 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
245 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246
247 if [ "${PATCH_SUFFIX}" != "patch" ]
248 then
249 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
250 then
251 echo
252 eerror "Could not extract patch!"
253 #die "Could not extract patch!"
254 count=5
255 break
256 fi
257 fi
258
259 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
260 then
261 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
263 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
264 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
265 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
266
267 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
268 _epatch_assert
269
270 if [ "$?" -ne 0 ]
271 then
272 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
273 echo
274 eerror "A dry-run of patch command succeeded, but actually"
275 eerror "applying the patch failed!"
276 #die "Real world sux compared to the dreamworld!"
277 count=5
278 fi
279
280 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
281
282 break
283 fi
284
285 count=$((count + 1))
286 done
287
288 if [ "${PATCH_SUFFIX}" != "patch" ]
289 then
290 rm -f ${PATCH_TARGET}
291 fi
292
293 if [ "${count}" -eq 5 ]
294 then
295 echo
296 eerror "Failed Patch: ${patchname} !"
297 eerror " ( ${PATCH_TARGET} )"
298 eerror
299 eerror "Include in your bugreport the contents of:"
300 eerror
301 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
302 echo
303 die "Failed Patch: ${patchname}!" 501 die "Failed Patch: ${patchname}!"
304 fi 502 fi
305 503
306 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 504 # if everything worked, delete the patch log
307 505 rm -f "${STDERR_TARGET}"
308 eend 0 506 eend 0
309 fi
310 done 507 done
311 if [ "${SINGLE_PATCH}" = "no" ] 508
312 then 509 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
313 einfo "Done with patching" 510 : # everything worked
511}
512
513# @FUNCTION: epatch_user
514# @USAGE:
515# @DESCRIPTION:
516# Applies user-provided patches to the source tree. The patches are
517# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
518# of these three directories to exist will be the one to use, ignoring
519# any more general directories which might exist as well.
520#
521# User patches are intended for quick testing of patches without ebuild
522# modifications, as well as for permanent customizations a user might
523# desire. Obviously, there can be no official support for arbitrarily
524# patched ebuilds. So whenever a build log in a bug report mentions that
525# user patches were applied, the user should be asked to reproduce the
526# problem without these.
527#
528# Not all ebuilds do call this function, so placing patches in the
529# stated directory might or might not work, depending on the package and
530# the eclasses it inherits and uses. It is safe to call the function
531# repeatedly, so it is always possible to add a call at the ebuild
532# level. The first call is the time when the patches will be
533# applied.
534#
535# Ideally, this function should be called after gentoo-specific patches
536# have been applied, so that their code can be modified as well, but
537# before calls to e.g. eautoreconf, as the user patches might affect
538# autotool input files as well.
539epatch_user() {
540 [[ $# -ne 0 ]] && die "epatch_user takes no options"
541
542 # Allow multiple calls to this function; ignore all but the first
543 local applied="${T}/epatch_user.applied"
544 [[ -e ${applied} ]] && return 2
545
546 # don't clobber any EPATCH vars that the parent might want
547 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
548 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
549 EPATCH_SOURCE=${base}/${CTARGET}/${check}
550 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
551 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
552 if [[ -d ${EPATCH_SOURCE} ]] ; then
553 EPATCH_SOURCE=${EPATCH_SOURCE} \
554 EPATCH_SUFFIX="patch" \
555 EPATCH_FORCE="yes" \
556 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
557 epatch
558 echo "${EPATCH_SOURCE}" > "${applied}"
559 return 0
314 fi 560 fi
561 done
562 echo "none" > "${applied}"
563 return 1
315} 564}
316 565
317# @FUNCTION: emktemp 566# @FUNCTION: emktemp
318# @USAGE: [temp dir] 567# @USAGE: [temp dir]
319# @DESCRIPTION: 568# @DESCRIPTION:
347 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 596 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
348 fi 597 fi
349 fi 598 fi
350} 599}
351 600
352# @FUNCTION: egetent
353# @USAGE: <database> <key>
354# @MAINTAINER:
355# base-system@gentoo.org (Linux)
356# Joe Jezak <josejx@gmail.com> (OS X)
357# usata@gentoo.org (OS X)
358# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
359# @DESCRIPTION:
360# Small wrapper for getent (Linux), nidump (Mac OS X),
361# and pw (FreeBSD) used in enewuser()/enewgroup()
362egetent() {
363 case ${CHOST} in
364 *-darwin*)
365 case "$2" in
366 *[!0-9]*) # Non numeric
367 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
368 ;;
369 *) # Numeric
370 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
371 ;;
372 esac
373 ;;
374 *-freebsd*|*-dragonfly*)
375 local opts action="user"
376 [[ $1 == "passwd" ]] || action="group"
377
378 # lookup by uid/gid
379 if [[ $2 == [[:digit:]]* ]] ; then
380 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
381 fi
382
383 pw show ${action} ${opts} "$2" -q
384 ;;
385 *-netbsd*|*-openbsd*)
386 grep "$2:\*:" /etc/$1
387 ;;
388 *)
389 type -p nscd >& /dev/null && nscd -i "$1"
390 getent "$1" "$2"
391 ;;
392 esac
393}
394
395# @FUNCTION: enewuser
396# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
397# @DESCRIPTION:
398# Same as enewgroup, you are not required to understand how to properly add
399# a user to the system. The only required parameter is the username.
400# Default uid is (pass -1 for this) next available, default shell is
401# /bin/false, default homedir is /dev/null, there are no default groups,
402# and default params sets the comment as 'added by portage for ${PN}'.
403enewuser() {
404 case ${EBUILD_PHASE} in
405 unpack|compile|test|install)
406 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
407 eerror "Package fails at QA and at life. Please file a bug."
408 die "Bad package! enewuser is only for use in pkg_* functions!"
409 esac
410
411 # get the username
412 local euser=$1; shift
413 if [[ -z ${euser} ]] ; then
414 eerror "No username specified !"
415 die "Cannot call enewuser without a username"
416 fi
417
418 # lets see if the username already exists
419 if [[ -n $(egetent passwd "${euser}") ]] ; then
420 return 0
421 fi
422 einfo "Adding user '${euser}' to your system ..."
423
424 # options to pass to useradd
425 local opts=
426
427 # handle uid
428 local euid=$1; shift
429 if [[ -n ${euid} && ${euid} != -1 ]] ; then
430 if [[ ${euid} -gt 0 ]] ; then
431 if [[ -n $(egetent passwd ${euid}) ]] ; then
432 euid="next"
433 fi
434 else
435 eerror "Userid given but is not greater than 0 !"
436 die "${euid} is not a valid UID"
437 fi
438 else
439 euid="next"
440 fi
441 if [[ ${euid} == "next" ]] ; then
442 for ((euid = 101; euid <= 999; euid++)); do
443 [[ -z $(egetent passwd ${euid}) ]] && break
444 done
445 fi
446 opts="${opts} -u ${euid}"
447 einfo " - Userid: ${euid}"
448
449 # handle shell
450 local eshell=$1; shift
451 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
452 if [[ ! -e ${ROOT}${eshell} ]] ; then
453 eerror "A shell was specified but it does not exist !"
454 die "${eshell} does not exist in ${ROOT}"
455 fi
456 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
457 eerror "Do not specify ${eshell} yourself, use -1"
458 die "Pass '-1' as the shell parameter"
459 fi
460 else
461 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
462 [[ -x ${ROOT}${shell} ]] && break
463 done
464
465 if [[ ${shell} == "/dev/null" ]] ; then
466 eerror "Unable to identify the shell to use, proceeding with userland default."
467 case ${USERLAND} in
468 GNU) shell="/bin/false" ;;
469 BSD) shell="/sbin/nologin" ;;
470 Darwin) shell="/usr/sbin/nologin" ;;
471 *) die "Unable to identify the default shell for userland ${USERLAND}"
472 esac
473 fi
474
475 eshell=${shell}
476 fi
477 einfo " - Shell: ${eshell}"
478 opts="${opts} -s ${eshell}"
479
480 # handle homedir
481 local ehome=$1; shift
482 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
483 ehome="/dev/null"
484 fi
485 einfo " - Home: ${ehome}"
486 opts="${opts} -d ${ehome}"
487
488 # handle groups
489 local egroups=$1; shift
490 if [[ ! -z ${egroups} ]] ; then
491 local oldifs=${IFS}
492 local defgroup="" exgroups=""
493
494 export IFS=","
495 for g in ${egroups} ; do
496 export IFS=${oldifs}
497 if [[ -z $(egetent group "${g}") ]] ; then
498 eerror "You must add group ${g} to the system first"
499 die "${g} is not a valid GID"
500 fi
501 if [[ -z ${defgroup} ]] ; then
502 defgroup=${g}
503 else
504 exgroups="${exgroups},${g}"
505 fi
506 export IFS=","
507 done
508 export IFS=${oldifs}
509
510 opts="${opts} -g ${defgroup}"
511 if [[ ! -z ${exgroups} ]] ; then
512 opts="${opts} -G ${exgroups:1}"
513 fi
514 else
515 egroups="(none)"
516 fi
517 einfo " - Groups: ${egroups}"
518
519 # handle extra and add the user
520 local oldsandbox=${SANDBOX_ON}
521 export SANDBOX_ON="0"
522 case ${CHOST} in
523 *-darwin*)
524 ### Make the user
525 if [[ -z $@ ]] ; then
526 dscl . create /users/${euser} uid ${euid}
527 dscl . create /users/${euser} shell ${eshell}
528 dscl . create /users/${euser} home ${ehome}
529 dscl . create /users/${euser} realname "added by portage for ${PN}"
530 ### Add the user to the groups specified
531 local oldifs=${IFS}
532 export IFS=","
533 for g in ${egroups} ; do
534 dscl . merge /groups/${g} users ${euser}
535 done
536 export IFS=${oldifs}
537 else
538 einfo "Extra options are not supported on Darwin yet"
539 einfo "Please report the ebuild along with the info below"
540 einfo "eextra: $@"
541 die "Required function missing"
542 fi
543 ;;
544 *-freebsd*|*-dragonfly*)
545 if [[ -z $@ ]] ; then
546 pw useradd ${euser} ${opts} \
547 -c "added by portage for ${PN}" \
548 die "enewuser failed"
549 else
550 einfo " - Extra: $@"
551 pw useradd ${euser} ${opts} \
552 "$@" || die "enewuser failed"
553 fi
554 ;;
555
556 *-netbsd*)
557 if [[ -z $@ ]] ; then
558 useradd ${opts} ${euser} || die "enewuser failed"
559 else
560 einfo " - Extra: $@"
561 useradd ${opts} ${euser} "$@" || die "enewuser failed"
562 fi
563 ;;
564
565 *-openbsd*)
566 if [[ -z $@ ]] ; then
567 useradd -u ${euid} -s ${eshell} \
568 -d ${ehome} -c "Added by portage for ${PN}" \
569 -g ${egroups} ${euser} || die "enewuser failed"
570 else
571 einfo " - Extra: $@"
572 useradd -u ${euid} -s ${eshell} \
573 -d ${ehome} -c "Added by portage for ${PN}" \
574 -g ${egroups} ${euser} "$@" || die "enewuser failed"
575 fi
576 ;;
577
578 *)
579 if [[ -z $@ ]] ; then
580 useradd ${opts} ${euser} \
581 -c "added by portage for ${PN}" \
582 || die "enewuser failed"
583 else
584 einfo " - Extra: $@"
585 useradd ${opts} ${euser} "$@" \
586 || die "enewuser failed"
587 fi
588 ;;
589 esac
590
591 if [[ ! -e ${ROOT}/${ehome} ]] ; then
592 einfo " - Creating ${ehome} in ${ROOT}"
593 mkdir -p "${ROOT}/${ehome}"
594 chown ${euser} "${ROOT}/${ehome}"
595 chmod 755 "${ROOT}/${ehome}"
596 fi
597
598 export SANDBOX_ON=${oldsandbox}
599}
600
601# @FUNCTION: enewgroup
602# @USAGE: <group> [gid]
603# @DESCRIPTION:
604# This function does not require you to understand how to properly add a
605# group to the system. Just give it a group name to add and enewgroup will
606# do the rest. You may specify the gid for the group or allow the group to
607# allocate the next available one.
608enewgroup() {
609 case ${EBUILD_PHASE} in
610 unpack|compile|test|install)
611 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
612 eerror "Package fails at QA and at life. Please file a bug."
613 die "Bad package! enewgroup is only for use in pkg_* functions!"
614 esac
615
616 # get the group
617 local egroup="$1"; shift
618 if [ -z "${egroup}" ]
619 then
620 eerror "No group specified !"
621 die "Cannot call enewgroup without a group"
622 fi
623
624 # see if group already exists
625 if [[ -n $(egetent group "${egroup}") ]]; then
626 return 0
627 fi
628 einfo "Adding group '${egroup}' to your system ..."
629
630 # options to pass to useradd
631 local opts=
632
633 # handle gid
634 local egid="$1"; shift
635 if [ ! -z "${egid}" ]
636 then
637 if [ "${egid}" -gt 0 ]
638 then
639 if [ -z "`egetent group ${egid}`" ]
640 then
641 if [[ "${CHOST}" == *-darwin* ]]; then
642 opts="${opts} ${egid}"
643 else
644 opts="${opts} -g ${egid}"
645 fi
646 else
647 egid="next available; requested gid taken"
648 fi
649 else
650 eerror "Groupid given but is not greater than 0 !"
651 die "${egid} is not a valid GID"
652 fi
653 else
654 egid="next available"
655 fi
656 einfo " - Groupid: ${egid}"
657
658 # handle extra
659 local eextra="$@"
660 opts="${opts} ${eextra}"
661
662 # add the group
663 local oldsandbox="${SANDBOX_ON}"
664 export SANDBOX_ON="0"
665 case ${CHOST} in
666 *-darwin*)
667 if [ ! -z "${eextra}" ];
668 then
669 einfo "Extra options are not supported on Darwin/OS X yet"
670 einfo "Please report the ebuild along with the info below"
671 einfo "eextra: ${eextra}"
672 die "Required function missing"
673 fi
674
675 # If we need the next available
676 case ${egid} in
677 *[!0-9]*) # Non numeric
678 for ((egid = 101; egid <= 999; egid++)); do
679 [[ -z $(egetent group ${egid}) ]] && break
680 done
681 esac
682 dscl . create /groups/${egroup} gid ${egid}
683 dscl . create /groups/${egroup} passwd '*'
684 ;;
685
686 *-freebsd*|*-dragonfly*)
687 case ${egid} in
688 *[!0-9]*) # Non numeric
689 for ((egid = 101; egid <= 999; egid++)); do
690 [[ -z $(egetent group ${egid}) ]] && break
691 done
692 esac
693 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
694 ;;
695
696 *-netbsd*)
697 case ${egid} in
698 *[!0-9]*) # Non numeric
699 for ((egid = 101; egid <= 999; egid++)); do
700 [[ -z $(egetent group ${egid}) ]] && break
701 done
702 esac
703 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
704 ;;
705
706 *)
707 groupadd ${opts} ${egroup} || die "enewgroup failed"
708 ;;
709 esac
710 export SANDBOX_ON="${oldsandbox}"
711}
712
713# @FUNCTION: edos2unix 601# @FUNCTION: edos2unix
714# @USAGE: <file> [more files ...] 602# @USAGE: <file> [more files ...]
715# @DESCRIPTION: 603# @DESCRIPTION:
716# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 604# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
717# to remove all of these text utilities from DEPEND variables because this 605# to remove all of these text utilities from DEPEND variables because this
718# is a script based solution. Just give it a list of files to convert and 606# is a script based solution. Just give it a list of files to convert and
719# they will all be changed from the DOS CRLF format to the UNIX LF format. 607# they will all be changed from the DOS CRLF format to the UNIX LF format.
720edos2unix() { 608edos2unix() {
721 echo "$@" | xargs sed -i 's/\r$//' 609 [[ $# -eq 0 ]] && return 0
610 sed -i 's/\r$//' -- "$@" || die
722} 611}
723 612
613# @FUNCTION: make_desktop_entry
614# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
615# @DESCRIPTION:
724# Make a desktop file ! 616# Make a .desktop file.
725# Great for making those icons in kde/gnome startmenu !
726# Amaze your friends ! Get the women ! Join today !
727# 617#
728# make_desktop_entry(<command>, [name], [icon], [type], [path]) 618# @CODE
729#
730# binary: what command does the app run with ? 619# binary: what command does the app run with ?
731# name: the name that will show up in the menu 620# name: the name that will show up in the menu
732# icon: give your little like a pretty little icon ... 621# icon: give your little like a pretty little icon ...
733# this can be relative (to /usr/share/pixmaps) or 622# this can be relative (to /usr/share/pixmaps) or
734# a full path to an icon 623# a full path to an icon
735# type: what kind of application is this ? for categories: 624# type: what kind of application is this?
625# for categories:
736# http://standards.freedesktop.org/menu-spec/latest/apa.html 626# http://standards.freedesktop.org/menu-spec/latest/apa.html
737# path: if your app needs to startup in a specific dir 627# if unset, function tries to guess from package's category
628# fields: extra fields to append to the desktop file; a printf string
629# @CODE
738make_desktop_entry() { 630make_desktop_entry() {
739 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 631 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
740 632
741 local exec=${1} 633 local exec=${1}
742 local name=${2:-${PN}} 634 local name=${2:-${PN}}
743 local icon=${3:-${PN}} 635 local icon=${3:-${PN}}
744 local type=${4} 636 local type=${4}
745 local path=${5} 637 local fields=${5}
746 638
747 if [[ -z ${type} ]] ; then 639 if [[ -z ${type} ]] ; then
748 local catmaj=${CATEGORY%%-*} 640 local catmaj=${CATEGORY%%-*}
749 local catmin=${CATEGORY##*-} 641 local catmin=${CATEGORY##*-}
750 case ${catmaj} in 642 case ${catmaj} in
751 app) 643 app)
752 case ${catmin} in 644 case ${catmin} in
753 accessibility) type=Accessibility;; 645 accessibility) type=Accessibility;;
754 admin) type=System;; 646 admin) type=System;;
755 antivirus) type=System;; 647 antivirus) type=System;;
756 arch) type=Archiving;; 648 arch) type=Archiving;;
757 backup) type=Archiving;; 649 backup) type=Archiving;;
758 cdr) type=DiscBurning;; 650 cdr) type=DiscBurning;;
759 dicts) type=Dictionary;; 651 dicts) type=Dictionary;;
760 doc) type=Documentation;; 652 doc) type=Documentation;;
761 editors) type=TextEditor;; 653 editors) type=TextEditor;;
762 emacs) type=TextEditor;; 654 emacs) type=TextEditor;;
763 emulation) type=Emulator;; 655 emulation) type=Emulator;;
764 laptop) type=HardwareSettings;; 656 laptop) type=HardwareSettings;;
765 office) type=Office;; 657 office) type=Office;;
766 pda) type=PDA;; 658 pda) type=PDA;;
767 vim) type=TextEditor;; 659 vim) type=TextEditor;;
768 xemacs) type=TextEditor;; 660 xemacs) type=TextEditor;;
769 *) type=;;
770 esac 661 esac
771 ;; 662 ;;
772 663
773 dev) 664 dev)
774 type="Development" 665 type="Development"
775 ;; 666 ;;
776 667
777 games) 668 games)
778 case ${catmin} in 669 case ${catmin} in
779 action|fps) type=ActionGame;; 670 action|fps) type=ActionGame;;
780 arcade) type=ArcadeGame;; 671 arcade) type=ArcadeGame;;
781 board) type=BoardGame;; 672 board) type=BoardGame;;
782 emulation) type=Emulator;; 673 emulation) type=Emulator;;
783 kids) type=KidsGame;; 674 kids) type=KidsGame;;
784 puzzle) type=LogicGame;; 675 puzzle) type=LogicGame;;
785 roguelike) type=RolePlaying;; 676 roguelike) type=RolePlaying;;
786 rpg) type=RolePlaying;; 677 rpg) type=RolePlaying;;
787 simulation) type=Simulation;; 678 simulation) type=Simulation;;
788 sports) type=SportsGame;; 679 sports) type=SportsGame;;
789 strategy) type=StrategyGame;; 680 strategy) type=StrategyGame;;
790 *) type=;;
791 esac 681 esac
792 type="Game;${type}" 682 type="Game;${type}"
793 ;; 683 ;;
794 684
795 gnome) 685 gnome)
804 type="Network;Email" 694 type="Network;Email"
805 ;; 695 ;;
806 696
807 media) 697 media)
808 case ${catmin} in 698 case ${catmin} in
699 gfx)
809 gfx) type=Graphics;; 700 type=Graphics
701 ;;
702 *)
703 case ${catmin} in
810 radio) type=Tuner;; 704 radio) type=Tuner;;
811 sound) type=Audio;; 705 sound) type=Audio;;
812 tv) type=TV;; 706 tv) type=TV;;
813 video) type=Video;; 707 video) type=Video;;
814 *) type=;; 708 esac
709 type="AudioVideo;${type}"
710 ;;
815 esac 711 esac
816 type="AudioVideo;${type}"
817 ;; 712 ;;
818 713
819 net) 714 net)
820 case ${catmin} in 715 case ${catmin} in
821 dialup) type=Dialup;; 716 dialup) type=Dialup;;
822 ftp) type=FileTransfer;; 717 ftp) type=FileTransfer;;
823 im) type=InstantMessaging;; 718 im) type=InstantMessaging;;
824 irc) type=IRCClient;; 719 irc) type=IRCClient;;
825 mail) type=Email;; 720 mail) type=Email;;
826 news) type=News;; 721 news) type=News;;
827 nntp) type=News;; 722 nntp) type=News;;
828 p2p) type=FileTransfer;; 723 p2p) type=FileTransfer;;
829 *) type=;; 724 voip) type=Telephony;;
830 esac 725 esac
831 type="Network;${type}" 726 type="Network;${type}"
832 ;; 727 ;;
833 728
834 sci) 729 sci)
835 case ${catmin} in 730 case ${catmin} in
836 astro*) type=Astronomy;; 731 astro*) type=Astronomy;;
837 bio*) type=Biology;; 732 bio*) type=Biology;;
838 calc*) type=Calculator;; 733 calc*) type=Calculator;;
839 chem*) type=Chemistry;; 734 chem*) type=Chemistry;;
840 elec*) type=Electronics;; 735 elec*) type=Electronics;;
841 geo*) type=Geology;; 736 geo*) type=Geology;;
842 math*) type=Math;; 737 math*) type=Math;;
843 physics) type=Physics;; 738 physics) type=Physics;;
844 visual*) type=DataVisualization;; 739 visual*) type=DataVisualization;;
845 *) type=;;
846 esac 740 esac
847 type="Science;${type}" 741 type="Education;Science;${type}"
848 ;; 742 ;;
849 743
850 sys) 744 sys)
851 type="System" 745 type="System"
852 ;; 746 ;;
853 747
854 www) 748 www)
855 case ${catmin} in 749 case ${catmin} in
856 client) type=WebBrowser;; 750 client) type=WebBrowser;;
857 *) type=;;
858 esac 751 esac
859 type="Network" 752 type="Network;${type}"
860 ;; 753 ;;
861 754
862 *) 755 *)
863 type= 756 type=
864 ;; 757 ;;
870 local desktop_name="${PN}-${SLOT}" 763 local desktop_name="${PN}-${SLOT}"
871 fi 764 fi
872 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 765 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
873 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 766 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
874 767
768 # Don't append another ";" when a valid category value is provided.
769 type=${type%;}${type:+;}
770
771 eshopts_push -s extglob
772 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
773 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
774 ewarn "allowed in .desktop files if the value is not an absolute path."
775 icon=${icon%.@(xpm|png|svg)}
776 fi
777 eshopts_pop
778
875 cat <<-EOF > "${desktop}" 779 cat <<-EOF > "${desktop}"
876 [Desktop Entry] 780 [Desktop Entry]
877 Version=1.0
878 Name=${name} 781 Name=${name}
879 Type=Application 782 Type=Application
880 Comment=${DESCRIPTION} 783 Comment=${DESCRIPTION}
881 Exec=${exec} 784 Exec=${exec}
882 TryExec=${exec%% *} 785 TryExec=${exec%% *}
883 Icon=${icon} 786 Icon=${icon}
884 Categories=${type}; 787 Categories=${type}
885 EOF 788 EOF
886 789
887 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 790 if [[ ${fields:-=} != *=* ]] ; then
791 # 5th arg used to be value to Path=
792 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
793 fields="Path=${fields}"
794 fi
795 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
888 796
889 ( 797 (
890 # wrap the env here so that the 'insinto' call 798 # wrap the env here so that the 'insinto' call
891 # doesn't corrupt the env of the caller 799 # doesn't corrupt the env of the caller
892 insinto /usr/share/applications 800 insinto /usr/share/applications
893 doins "${desktop}" 801 doins "${desktop}"
894 ) 802 ) || die "installing desktop file failed"
895} 803}
896 804
897# @FUNCTION: validate_desktop_entries 805# @FUNCTION: validate_desktop_entries
898# @USAGE: [directories] 806# @USAGE: [directories]
899# @MAINTAINER: 807# @MAINTAINER:
921 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 829 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
922 fi 830 fi
923} 831}
924 832
925# @FUNCTION: make_session_desktop 833# @FUNCTION: make_session_desktop
926# @USAGE: <title> <command> 834# @USAGE: <title> <command> [command args...]
927# @DESCRIPTION: 835# @DESCRIPTION:
928# Make a GDM/KDM Session file. The title is the file to execute to start the 836# Make a GDM/KDM Session file. The title is the file to execute to start the
929# Window Manager. The command is the name of the Window Manager. 837# Window Manager. The command is the name of the Window Manager.
838#
839# You can set the name of the file via the ${wm} variable.
930make_session_desktop() { 840make_session_desktop() {
931 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 841 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
932 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 842 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
933 843
934 local title=$1 844 local title=$1
935 local command=$2 845 local command=$2
936 local desktop=${T}/${wm}.desktop 846 local desktop=${T}/${wm:-${PN}}.desktop
847 shift 2
937 848
938 cat <<-EOF > "${desktop}" 849 cat <<-EOF > "${desktop}"
939 [Desktop Entry] 850 [Desktop Entry]
940 Name=${title} 851 Name=${title}
941 Comment=This session logs you into ${title} 852 Comment=This session logs you into ${title}
942 Exec=${command} 853 Exec=${command} $*
943 TryExec=${command} 854 TryExec=${command}
944 Type=Application 855 Type=XSession
945 EOF 856 EOF
946 857
947 ( 858 (
948 # wrap the env here so that the 'insinto' call 859 # wrap the env here so that the 'insinto' call
949 # doesn't corrupt the env of the caller 860 # doesn't corrupt the env of the caller
1030 # wrap the env here so that the 'insinto' call 941 # wrap the env here so that the 'insinto' call
1031 # doesn't corrupt the env of the caller 942 # doesn't corrupt the env of the caller
1032 insinto /usr/share/pixmaps 943 insinto /usr/share/pixmaps
1033 newins "$@" 944 newins "$@"
1034 ) 945 )
1035}
1036
1037# for internal use only (unpack_pdv and unpack_makeself)
1038find_unpackable_file() {
1039 local src=$1
1040 if [[ -z ${src} ]] ; then
1041 src=${DISTDIR}/${A}
1042 else
1043 if [[ -e ${DISTDIR}/${src} ]] ; then
1044 src=${DISTDIR}/${src}
1045 elif [[ -e ${PWD}/${src} ]] ; then
1046 src=${PWD}/${src}
1047 elif [[ -e ${src} ]] ; then
1048 src=${src}
1049 fi
1050 fi
1051 [[ ! -e ${src} ]] && return 1
1052 echo "${src}"
1053}
1054
1055# @FUNCTION: unpack_pdv
1056# @USAGE: <file to unpack> <size of off_t>
1057# @DESCRIPTION:
1058# Unpack those pesky pdv generated files ...
1059# They're self-unpacking programs with the binary package stuffed in
1060# the middle of the archive. Valve seems to use it a lot ... too bad
1061# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1062#
1063# You have to specify the off_t size ... I have no idea how to extract that
1064# information out of the binary executable myself. Basically you pass in
1065# the size of the off_t type (in bytes) on the machine that built the pdv
1066# archive.
1067#
1068# One way to determine this is by running the following commands:
1069#
1070# @CODE
1071# strings <pdv archive> | grep lseek
1072# strace -elseek <pdv archive>
1073# @CODE
1074#
1075# Basically look for the first lseek command (we do the strings/grep because
1076# sometimes the function call is _llseek or something) and steal the 2nd
1077# parameter. Here is an example:
1078#
1079# @CODE
1080# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1081# lseek
1082# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1083# lseek(3, -4, SEEK_END) = 2981250
1084# @CODE
1085#
1086# Thus we would pass in the value of '4' as the second parameter.
1087unpack_pdv() {
1088 local src=$(find_unpackable_file "$1")
1089 local sizeoff_t=$2
1090
1091 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1092 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1093
1094 local shrtsrc=$(basename "${src}")
1095 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1096 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1097 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1098
1099 # grab metadata for debug reasons
1100 local metafile=$(emktemp)
1101 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1102
1103 # rip out the final file name from the metadata
1104 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1105 datafile=$(basename "${datafile}")
1106
1107 # now lets uncompress/untar the file if need be
1108 local tmpfile=$(emktemp)
1109 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1110
1111 local iscompressed=$(file -b "${tmpfile}")
1112 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1113 iscompressed=1
1114 mv ${tmpfile}{,.Z}
1115 gunzip ${tmpfile}
1116 else
1117 iscompressed=0
1118 fi
1119 local istar=$(file -b "${tmpfile}")
1120 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1121 istar=1
1122 else
1123 istar=0
1124 fi
1125
1126 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1127 #dd if=${src} ibs=${metaskip} count=1 \
1128 # | dd ibs=${tailskip} skip=1 \
1129 # | gzip -dc \
1130 # > ${datafile}
1131 if [ ${iscompressed} -eq 1 ] ; then
1132 if [ ${istar} -eq 1 ] ; then
1133 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1134 | head -c $((${metaskip}-${tailskip})) \
1135 | tar -xzf -
1136 else
1137 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1138 | head -c $((${metaskip}-${tailskip})) \
1139 | gzip -dc \
1140 > ${datafile}
1141 fi
1142 else
1143 if [ ${istar} -eq 1 ] ; then
1144 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1145 | head -c $((${metaskip}-${tailskip})) \
1146 | tar --no-same-owner -xf -
1147 else
1148 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1149 | head -c $((${metaskip}-${tailskip})) \
1150 > ${datafile}
1151 fi
1152 fi
1153 true
1154 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1155 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1156}
1157
1158# @FUNCTION: unpack_makeself
1159# @USAGE: [file to unpack] [offset] [tail|dd]
1160# @DESCRIPTION:
1161# Unpack those pesky makeself generated files ...
1162# They're shell scripts with the binary package tagged onto
1163# the end of the archive. Loki utilized the format as does
1164# many other game companies.
1165#
1166# If the file is not specified, then ${A} is used. If the
1167# offset is not specified then we will attempt to extract
1168# the proper offset from the script itself.
1169unpack_makeself() {
1170 local src_input=${1:-${A}}
1171 local src=$(find_unpackable_file "${src_input}")
1172 local skip=$2
1173 local exe=$3
1174
1175 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1176
1177 local shrtsrc=$(basename "${src}")
1178 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1179 if [[ -z ${skip} ]] ; then
1180 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1181 local skip=0
1182 exe=tail
1183 case ${ver} in
1184 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1185 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1186 ;;
1187 2.0|2.0.1)
1188 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1189 ;;
1190 2.1.1)
1191 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1192 let skip="skip + 1"
1193 ;;
1194 2.1.2)
1195 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1196 let skip="skip + 1"
1197 ;;
1198 2.1.3)
1199 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1200 let skip="skip + 1"
1201 ;;
1202 2.1.4|2.1.5)
1203 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1204 skip=$(head -n ${skip} "${src}" | wc -c)
1205 exe="dd"
1206 ;;
1207 *)
1208 eerror "I'm sorry, but I was unable to support the Makeself file."
1209 eerror "The version I detected was '${ver}'."
1210 eerror "Please file a bug about the file ${shrtsrc} at"
1211 eerror "http://bugs.gentoo.org/ so that support can be added."
1212 die "makeself version '${ver}' not supported"
1213 ;;
1214 esac
1215 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1216 fi
1217 case ${exe} in
1218 tail) exe="tail -n +${skip} '${src}'";;
1219 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1220 *) die "makeself cant handle exe '${exe}'"
1221 esac
1222
1223 # lets grab the first few bytes of the file to figure out what kind of archive it is
1224 local tmpfile=$(emktemp)
1225 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1226 local filetype=$(file -b "${tmpfile}")
1227 case ${filetype} in
1228 *tar\ archive*)
1229 eval ${exe} | tar --no-same-owner -xf -
1230 ;;
1231 bzip2*)
1232 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1233 ;;
1234 gzip*)
1235 eval ${exe} | tar --no-same-owner -xzf -
1236 ;;
1237 compress*)
1238 eval ${exe} | gunzip | tar --no-same-owner -xf -
1239 ;;
1240 *)
1241 eerror "Unknown filetype \"${filetype}\" ?"
1242 false
1243 ;;
1244 esac
1245 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1246}
1247
1248# @FUNCTION: check_license
1249# @USAGE: [license]
1250# @DESCRIPTION:
1251# Display a license for user to accept. If no license is
1252# specified, then ${LICENSE} is used.
1253check_license() {
1254 local lic=$1
1255 if [ -z "${lic}" ] ; then
1256 lic="${PORTDIR}/licenses/${LICENSE}"
1257 else
1258 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1259 lic="${PORTDIR}/licenses/${lic}"
1260 elif [ -e "${PWD}/${lic}" ] ; then
1261 lic="${PWD}/${lic}"
1262 elif [ -e "${lic}" ] ; then
1263 lic="${lic}"
1264 fi
1265 fi
1266 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1267 local l="`basename ${lic}`"
1268
1269 # here is where we check for the licenses the user already
1270 # accepted ... if we don't find a match, we make the user accept
1271 local shopts=$-
1272 local alic
1273 set -o noglob #so that bash doesn't expand "*"
1274 for alic in ${ACCEPT_LICENSE} ; do
1275 if [[ ${alic} == ${l} ]]; then
1276 set +o noglob; set -${shopts} #reset old shell opts
1277 return 0
1278 fi
1279 done
1280 set +o noglob; set -$shopts #reset old shell opts
1281
1282 local licmsg=$(emktemp)
1283 cat <<-EOF > ${licmsg}
1284 **********************************************************
1285 The following license outlines the terms of use of this
1286 package. You MUST accept this license for installation to
1287 continue. When you are done viewing, hit 'q'. If you
1288 CTRL+C out of this, the install will not run!
1289 **********************************************************
1290
1291 EOF
1292 cat ${lic} >> ${licmsg}
1293 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1294 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1295 read alic
1296 case ${alic} in
1297 yes|Yes|y|Y)
1298 return 0
1299 ;;
1300 *)
1301 echo;echo;echo
1302 eerror "You MUST accept the license to continue! Exiting!"
1303 die "Failed to accept license"
1304 ;;
1305 esac
1306} 946}
1307 947
1308# @FUNCTION: cdrom_get_cds 948# @FUNCTION: cdrom_get_cds
1309# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...] 949# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1310# @DESCRIPTION: 950# @DESCRIPTION:
1358 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 998 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1359 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 999 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1360 export CDROM_SET=-1 1000 export CDROM_SET=-1
1361 for f in ${CDROM_CHECK_1//:/ } ; do 1001 for f in ${CDROM_CHECK_1//:/ } ; do
1362 ((++CDROM_SET)) 1002 ((++CDROM_SET))
1363 [[ -e ${CD_ROOT}/${f} ]] && break 1003 [[ -e ${CDROM_ROOT}/${f} ]] && break
1364 done 1004 done
1365 export CDROM_MATCH=${f} 1005 export CDROM_MATCH=${f}
1366 return 1006 return
1367 fi 1007 fi
1368 1008
1532# of the lists. 1172# of the lists.
1533strip-linguas() { 1173strip-linguas() {
1534 local ls newls nols 1174 local ls newls nols
1535 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1175 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1536 local op=$1; shift 1176 local op=$1; shift
1537 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1177 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1538 local d f 1178 local d f
1539 for d in "$@" ; do 1179 for d in "$@" ; do
1540 if [[ ${op} == "-u" ]] ; then 1180 if [[ ${op} == "-u" ]] ; then
1541 newls=${ls} 1181 newls=${ls}
1542 else 1182 else
1543 newls="" 1183 newls=""
1544 fi 1184 fi
1545 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1185 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1546 if [[ ${op} == "-i" ]] ; then 1186 if [[ ${op} == "-i" ]] ; then
1547 hasq ${f} ${ls} && newls="${newls} ${f}" 1187 has ${f} ${ls} && newls="${newls} ${f}"
1548 else 1188 else
1549 hasq ${f} ${ls} || newls="${newls} ${f}" 1189 has ${f} ${ls} || newls="${newls} ${f}"
1550 fi 1190 fi
1551 done 1191 done
1552 ls=${newls} 1192 ls=${newls}
1553 done 1193 done
1554 else 1194 else
1556 fi 1196 fi
1557 1197
1558 nols="" 1198 nols=""
1559 newls="" 1199 newls=""
1560 for f in ${LINGUAS} ; do 1200 for f in ${LINGUAS} ; do
1561 if hasq ${f} ${ls} ; then 1201 if has ${f} ${ls} ; then
1562 newls="${newls} ${f}" 1202 newls="${newls} ${f}"
1563 else 1203 else
1564 nols="${nols} ${f}" 1204 nols="${nols} ${f}"
1565 fi 1205 fi
1566 done 1206 done
1567 [[ -n ${nols} ]] \ 1207 [[ -n ${nols} ]] \
1568 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1208 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1569 export LINGUAS=${newls:1} 1209 export LINGUAS=${newls:1}
1570} 1210}
1571 1211
1572# @FUNCTION: preserve_old_lib 1212# @FUNCTION: preserve_old_lib
1573# @USAGE: <libs to preserve> [more libs] 1213# @USAGE: <libs to preserve> [more libs]
1583 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1223 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1584 die "Invalid preserve_old_lib() usage" 1224 die "Invalid preserve_old_lib() usage"
1585 fi 1225 fi
1586 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1226 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1587 1227
1228 # let portage worry about it
1229 has preserve-libs ${FEATURES} && return 0
1230
1588 local lib dir 1231 local lib dir
1589 for lib in "$@" ; do 1232 for lib in "$@" ; do
1590 [[ -e ${ROOT}/${lib} ]] || continue 1233 [[ -e ${ROOT}/${lib} ]] || continue
1591 dir=${lib%/*} 1234 dir=${lib%/*}
1592 dodir ${dir} || die "dodir ${dir} failed" 1235 dodir ${dir} || die "dodir ${dir} failed"
1602preserve_old_lib_notify() { 1245preserve_old_lib_notify() {
1603 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1246 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1604 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1247 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1605 die "Invalid preserve_old_lib_notify() usage" 1248 die "Invalid preserve_old_lib_notify() usage"
1606 fi 1249 fi
1250
1251 # let portage worry about it
1252 has preserve-libs ${FEATURES} && return 0
1607 1253
1608 local lib notice=0 1254 local lib notice=0
1609 for lib in "$@" ; do 1255 for lib in "$@" ; do
1610 [[ -e ${ROOT}/${lib} ]] || continue 1256 [[ -e ${ROOT}/${lib} ]] || continue
1611 if [[ ${notice} -eq 0 ]] ; then 1257 if [[ ${notice} -eq 0 ]] ; then
1615 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1261 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1616 ewarn "in order to remove these old dependencies. If you do not have this" 1262 ewarn "in order to remove these old dependencies. If you do not have this"
1617 ewarn "helper program, simply emerge the 'gentoolkit' package." 1263 ewarn "helper program, simply emerge the 'gentoolkit' package."
1618 ewarn 1264 ewarn
1619 fi 1265 fi
1266 # temp hack for #348634 #357225
1267 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1620 ewarn " # revdep-rebuild --library ${lib##*/}" 1268 ewarn " # revdep-rebuild --library '${lib}'"
1621 done 1269 done
1622 if [[ ${notice} -eq 1 ]] ; then 1270 if [[ ${notice} -eq 1 ]] ; then
1623 ewarn 1271 ewarn
1624 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1272 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1625 ewarn "delete the old libraries." 1273 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1274 for lib in "$@" ; do
1275 ewarn " # rm '${lib}'"
1276 done
1626 fi 1277 fi
1627} 1278}
1628 1279
1629# @FUNCTION: built_with_use 1280# @FUNCTION: built_with_use
1630# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1281# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1631# @DESCRIPTION: 1282# @DESCRIPTION:
1283#
1284# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1285#
1632# A temporary hack until portage properly supports DEPENDing on USE 1286# A temporary hack until portage properly supports DEPENDing on USE
1633# flags being enabled in packages. This will check to see if the specified 1287# flags being enabled in packages. This will check to see if the specified
1634# DEPEND atom was built with the specified list of USE flags. The 1288# DEPEND atom was built with the specified list of USE flags. The
1635# --missing option controls the behavior if called on a package that does 1289# --missing option controls the behavior if called on a package that does
1636# not actually support the defined USE flags (aka listed in IUSE). 1290# not actually support the defined USE flags (aka listed in IUSE).
1637# The default is to abort (call die). The -a and -o flags control 1291# The default is to abort (call die). The -a and -o flags control
1638# the requirements of the USE flags. They correspond to "and" and "or" 1292# the requirements of the USE flags. They correspond to "and" and "or"
1639# logic. So the -a flag means all listed USE flags must be enabled 1293# logic. So the -a flag means all listed USE flags must be enabled
1640# while the -o flag means at least one of the listed fIUSE flags must be 1294# while the -o flag means at least one of the listed IUSE flags must be
1641# enabled. The --hidden option is really for internal use only as it 1295# enabled. The --hidden option is really for internal use only as it
1642# means the USE flag we're checking is hidden expanded, so it won't be found 1296# means the USE flag we're checking is hidden expanded, so it won't be found
1643# in IUSE like normal USE flags. 1297# in IUSE like normal USE flags.
1644# 1298#
1645# Remember that this function isn't terribly intelligent so order of optional 1299# Remember that this function isn't terribly intelligent so order of optional
1680 die) die "Unable to determine what USE flags $PKG was built with";; 1334 die) die "Unable to determine what USE flags $PKG was built with";;
1681 esac 1335 esac
1682 fi 1336 fi
1683 1337
1684 if [[ ${hidden} == "no" ]] ; then 1338 if [[ ${hidden} == "no" ]] ; then
1685 local IUSE_BUILT=$(<${IUSEFILE}) 1339 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1686 # Don't check USE_EXPAND #147237 1340 # Don't check USE_EXPAND #147237
1687 local expand 1341 local expand
1688 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1342 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1689 if [[ $1 == ${expand}_* ]] ; then 1343 if [[ $1 == ${expand}_* ]] ; then
1690 expand="" 1344 expand=""
1691 break 1345 break
1692 fi 1346 fi
1693 done 1347 done
1694 if [[ -n ${expand} ]] ; then 1348 if [[ -n ${expand} ]] ; then
1695 if ! has $1 ${IUSE_BUILT} ; then 1349 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1696 case ${missing_action} in 1350 case ${missing_action} in
1697 true) return 0;; 1351 true) return 0;;
1698 false) return 1;; 1352 false) return 1;;
1699 die) die "$PKG does not actually support the $1 USE flag!";; 1353 die) die "$PKG does not actually support the $1 USE flag!";;
1700 esac 1354 esac
1764 ) || die 1418 ) || die
1765 else 1419 else
1766 newbin "${tmpwrapper}" "${wrapper}" || die 1420 newbin "${tmpwrapper}" "${wrapper}" || die
1767 fi 1421 fi
1768} 1422}
1423
1424# @FUNCTION: path_exists
1425# @USAGE: [-a|-o] <paths>
1426# @DESCRIPTION:
1427# Check if the specified paths exist. Works for all types of paths
1428# (files/dirs/etc...). The -a and -o flags control the requirements
1429# of the paths. They correspond to "and" and "or" logic. So the -a
1430# flag means all the paths must exist while the -o flag means at least
1431# one of the paths must exist. The default behavior is "and". If no
1432# paths are specified, then the return value is "false".
1433path_exists() {
1434 local opt=$1
1435 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1436
1437 # no paths -> return false
1438 # same behavior as: [[ -e "" ]]
1439 [[ $# -eq 0 ]] && return 1
1440
1441 local p r=0
1442 for p in "$@" ; do
1443 [[ -e ${p} ]]
1444 : $(( r += $? ))
1445 done
1446
1447 case ${opt} in
1448 -a) return $(( r != 0 )) ;;
1449 -o) return $(( r == $# )) ;;
1450 esac
1451}
1452
1453# @FUNCTION: in_iuse
1454# @USAGE: <flag>
1455# @DESCRIPTION:
1456# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1457# as necessary.
1458#
1459# Note that this function should not be used in the global scope.
1460in_iuse() {
1461 debug-print-function ${FUNCNAME} "${@}"
1462 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1463
1464 local flag=${1}
1465 local liuse=( ${IUSE} )
1466
1467 has "${flag}" "${liuse[@]#[+-]}"
1468}
1469
1470# @FUNCTION: use_if_iuse
1471# @USAGE: <flag>
1472# @DESCRIPTION:
1473# Return true if the given flag is in USE and IUSE.
1474#
1475# Note that this function should not be used in the global scope.
1476use_if_iuse() {
1477 in_iuse $1 || return 1
1478 use $1
1479}
1480
1481# @FUNCTION: usex
1482# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1483# @DESCRIPTION:
1484# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1485# otherwise echo [false output][false suffix] (defaults to "no").
1486usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1487
1488check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1489
1490fi

Legend:
Removed from v.1.296  
changed lines
  Added in v.1.382

  ViewVC Help
Powered by ViewVC 1.1.20